diff -Naur openssl-1.0.0q.orig/crypto/des/destest.c openssl-1.0.0q/crypto/des/destest.c
--- openssl-1.0.0q.orig/crypto/des/destest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/destest.c	2017-04-25 16:23:40.161527789 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #if defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_WIN16) || defined(OPENSSL_SYS_WINDOWS)
@@ -71,9 +73,13 @@
 #include OPENSSL_UNISTD
 #endif
 #else
+#ifndef OPERA_SMALL_VERSION
 #include <io.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #ifdef OPENSSL_NO_DES
 int main(int argc, char *argv[])
@@ -369,28 +375,28 @@
 		printf("Key error %d\n",j);
 		err=1;
 		}
-	memset(cbc_out,0,40);
-	memset(cbc_in,0,40);
-	i=strlen((char *)cbc_data)+1;
+	op_memset(cbc_out,0,40);
+	op_memset(cbc_in,0,40);
+	i=op_strlen((char *)cbc_data)+1;
 	/* i=((i+7)/8)*8; */
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
-	memset(iv2,'\0',sizeof iv2);
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memset(iv2,'\0',sizeof iv2);
 
 	DES_ede3_cbcm_encrypt(cbc_data,cbc_out,16L,&ks,&ks2,&ks3,&iv3,&iv2,
 			      DES_ENCRYPT);
 	DES_ede3_cbcm_encrypt(&cbc_data[16],&cbc_out[16],i-16,&ks,&ks2,&ks3,
 			      &iv3,&iv2,DES_ENCRYPT);
-	/*	if (memcmp(cbc_out,cbc3_ok,
-		(unsigned int)(strlen((char *)cbc_data)+1+7)/8*8) != 0)
+	/*	if (op_memcmp(cbc_out,cbc3_ok,
+		(unsigned int)(op_strlen((char *)cbc_data)+1+7)/8*8) != 0)
 		{
 		printf("des_ede3_cbc_encrypt encrypt error\n");
 		err=1;
 		}
 	*/
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
-	memset(iv2,'\0',sizeof iv2);
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memset(iv2,'\0',sizeof iv2);
 	DES_ede3_cbcm_encrypt(cbc_out,cbc_in,i,&ks,&ks2,&ks3,&iv3,&iv2,DES_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
 		{
 		unsigned int n;
 
@@ -409,20 +415,20 @@
 	for (i=0; i<NUM_TESTS; i++)
 		{
 		DES_set_key_unchecked(&key_data[i],&ks);
-		memcpy(in,plain_data[i],8);
-		memset(out,0,8);
-		memset(outin,0,8);
+		op_memcpy(in,plain_data[i],8);
+		op_memset(out,0,8);
+		op_memset(outin,0,8);
 		des_ecb_encrypt(&in,&out,ks,DES_ENCRYPT);
 		des_ecb_encrypt(&out,&outin,ks,DES_DECRYPT);
 
-		if (memcmp(out,cipher_data[i],8) != 0)
+		if (op_memcmp(out,cipher_data[i],8) != 0)
 			{
 			printf("Encryption error %2d\nk=%s p=%s o=%s act=%s\n",
 				i+1,pt(key_data[i]),pt(in),pt(cipher_data[i]),
 				pt(out));
 			err=1;
 			}
-		if (memcmp(in,outin,8) != 0)
+		if (op_memcmp(in,outin,8) != 0)
 			{
 			printf("Decryption error %2d\nk=%s p=%s o=%s act=%s\n",
 				i+1,pt(key_data[i]),pt(out),pt(in),pt(outin));
@@ -437,20 +443,20 @@
 		DES_set_key_unchecked(&key_data[i],&ks);
 		DES_set_key_unchecked(&key_data[i+1],&ks2);
 		DES_set_key_unchecked(&key_data[i+2],&ks3);
-		memcpy(in,plain_data[i],8);
-		memset(out,0,8);
-		memset(outin,0,8);
+		op_memcpy(in,plain_data[i],8);
+		op_memset(out,0,8);
+		op_memset(outin,0,8);
 		des_ecb2_encrypt(&in,&out,ks,ks2,DES_ENCRYPT);
 		des_ecb2_encrypt(&out,&outin,ks,ks2,DES_DECRYPT);
 
-		if (memcmp(out,cipher_ecb2[i],8) != 0)
+		if (op_memcmp(out,cipher_ecb2[i],8) != 0)
 			{
 			printf("Encryption error %2d\nk=%s p=%s o=%s act=%s\n",
 				i+1,pt(key_data[i]),pt(in),pt(cipher_ecb2[i]),
 				pt(out));
 			err=1;
 			}
-		if (memcmp(in,outin,8) != 0)
+		if (op_memcmp(in,outin,8) != 0)
 			{
 			printf("Decryption error %2d\nk=%s p=%s o=%s act=%s\n",
 				i+1,pt(key_data[i]),pt(out),pt(in),pt(outin));
@@ -465,21 +471,21 @@
 		printf("Key error %d\n",j);
 		err=1;
 		}
-	memset(cbc_out,0,40);
-	memset(cbc_in,0,40);
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memset(cbc_out,0,40);
+	op_memset(cbc_in,0,40);
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 	des_ncbc_encrypt(cbc_data,cbc_out,strlen((char *)cbc_data)+1,ks,
 			 &iv3,DES_ENCRYPT);
-	if (memcmp(cbc_out,cbc_ok,32) != 0)
+	if (op_memcmp(cbc_out,cbc_ok,32) != 0)
 		{
 		printf("cbc_encrypt encrypt error\n");
 		err=1;
 		}
 
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 	des_ncbc_encrypt(cbc_out,cbc_in,strlen((char *)cbc_data)+1,ks,
 			 &iv3,DES_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)) != 0)
 		{
 		printf("cbc_encrypt decrypt error\n");
 		err=1;
@@ -492,20 +498,20 @@
 		printf("Key error %d\n",j);
 		err=1;
 		}
-	memset(cbc_out,0,40);
-	memset(cbc_in,0,40);
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memset(cbc_out,0,40);
+	op_memset(cbc_in,0,40);
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 	des_xcbc_encrypt(cbc_data,cbc_out,strlen((char *)cbc_data)+1,ks,
 			 &iv3,&cbc2_key,&cbc3_key, DES_ENCRYPT);
-	if (memcmp(cbc_out,xcbc_ok,32) != 0)
+	if (op_memcmp(cbc_out,xcbc_ok,32) != 0)
 		{
 		printf("des_xcbc_encrypt encrypt error\n");
 		err=1;
 		}
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 	des_xcbc_encrypt(cbc_out,cbc_in,strlen((char *)cbc_data)+1,ks,
 			 &iv3,&cbc2_key,&cbc3_key, DES_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
 		{
 		printf("des_xcbc_encrypt decrypt error\n");
 		err=1;
@@ -528,18 +534,18 @@
 		printf("Key error %d\n",j);
 		err=1;
 		}
-	memset(cbc_out,0,40);
-	memset(cbc_in,0,40);
-	i=strlen((char *)cbc_data)+1;
+	op_memset(cbc_out,0,40);
+	op_memset(cbc_in,0,40);
+	i=op_strlen((char *)cbc_data)+1;
 	/* i=((i+7)/8)*8; */
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 
 	des_ede3_cbc_encrypt(cbc_data,cbc_out,16L,ks,ks2,ks3,&iv3,
 			     DES_ENCRYPT);
 	des_ede3_cbc_encrypt(&(cbc_data[16]),&(cbc_out[16]),i-16,ks,ks2,ks3,
 			     &iv3,DES_ENCRYPT);
-	if (memcmp(cbc_out,cbc3_ok,
-		(unsigned int)(strlen((char *)cbc_data)+1+7)/8*8) != 0)
+	if (op_memcmp(cbc_out,cbc3_ok,
+		(unsigned int)(op_strlen((char *)cbc_data)+1+7)/8*8) != 0)
 		{
 		unsigned int n;
 
@@ -553,9 +559,9 @@
 		err=1;
 		}
 
-	memcpy(iv3,cbc_iv,sizeof(cbc_iv));
+	op_memcpy(iv3,cbc_iv,sizeof(cbc_iv));
 	des_ede3_cbc_encrypt(cbc_out,cbc_in,i,ks,ks2,ks3,&iv3,DES_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
 		{
 		unsigned int n;
 
@@ -576,18 +582,18 @@
 		printf("Key error %d\n",j);
 		err=1;
 		}
-	memset(cbc_out,0,40);
-	memset(cbc_in,0,40);
+	op_memset(cbc_out,0,40);
+	op_memset(cbc_in,0,40);
 	des_pcbc_encrypt(cbc_data,cbc_out,strlen((char *)cbc_data)+1,ks,
 			 &cbc_iv,DES_ENCRYPT);
-	if (memcmp(cbc_out,pcbc_ok,32) != 0)
+	if (op_memcmp(cbc_out,pcbc_ok,32) != 0)
 		{
 		printf("pcbc_encrypt encrypt error\n");
 		err=1;
 		}
 	des_pcbc_encrypt(cbc_out,cbc_in,strlen((char *)cbc_data)+1,ks,&cbc_iv,
 			 DES_DECRYPT);
-	if (memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
+	if (op_memcmp(cbc_in,cbc_data,strlen((char *)cbc_data)+1) != 0)
 		{
 		printf("pcbc_encrypt decrypt error\n");
 		err=1;
@@ -608,21 +614,21 @@
 	printf("cfb64() ");
 	err+=cfb64_test(cfb_cipher64);
 
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	for (i=0; i<sizeof(plain); i++)
 		des_cfb_encrypt(&(plain[i]),&(cfb_buf1[i]),
 			8,1,ks,&cfb_tmp,DES_ENCRYPT);
-	if (memcmp(cfb_cipher8,cfb_buf1,sizeof(plain)) != 0)
+	if (op_memcmp(cfb_cipher8,cfb_buf1,sizeof(plain)) != 0)
 		{
 		printf("cfb_encrypt small encrypt error\n");
 		err=1;
 		}
 
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	for (i=0; i<sizeof(plain); i++)
 		des_cfb_encrypt(&(cfb_buf1[i]),&(cfb_buf2[i]),
 			8,1,ks,&cfb_tmp,DES_DECRYPT);
-	if (memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
+	if (op_memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
 		{
 		printf("cfb_encrypt small decrypt error\n");
 		err=1;
@@ -635,9 +641,9 @@
 
 	printf("Doing ofb\n");
 	DES_set_key_checked(&ofb_key,&ks);
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
 	des_ofb_encrypt(plain,ofb_buf1,64,sizeof(plain)/8,ks,&ofb_tmp);
-	if (memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
+	if (op_memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
 		{
 		printf("ofb_encrypt encrypt error\n");
 printf("%02X %02X %02X %02X %02X %02X %02X %02X\n",
@@ -648,9 +654,9 @@
 ofb_buf1[8+4], ofb_cipher[8+5], ofb_cipher[8+6], ofb_cipher[8+7]);
 		err=1;
 		}
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
 	des_ofb_encrypt(ofb_buf1,ofb_buf2,64,sizeof(ofb_buf1)/8,ks,&ofb_tmp);
-	if (memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
+	if (op_memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
 		{
 		printf("ofb_encrypt decrypt error\n");
 printf("%02X %02X %02X %02X %02X %02X %02X %02X\n",
@@ -664,25 +670,25 @@
 
 	printf("Doing ofb64\n");
 	DES_set_key_checked(&ofb_key,&ks);
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
-	memset(ofb_buf1,0,sizeof(ofb_buf1));
-	memset(ofb_buf2,0,sizeof(ofb_buf1));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memset(ofb_buf1,0,sizeof(ofb_buf1));
+	op_memset(ofb_buf2,0,sizeof(ofb_buf1));
 	num=0;
 	for (i=0; i<sizeof(plain); i++)
 		{
 		des_ofb64_encrypt(&(plain[i]),&(ofb_buf1[i]),1,ks,&ofb_tmp,
 				  &num);
 		}
-	if (memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
+	if (op_memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
 		{
 		printf("ofb64_encrypt encrypt error\n");
 		err=1;
 		}
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
 	num=0;
 	des_ofb64_encrypt(ofb_buf1,ofb_buf2,sizeof(ofb_buf1),ks,&ofb_tmp,
 			  &num);
-	if (memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
+	if (op_memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
 		{
 		printf("ofb64_encrypt decrypt error\n");
 		err=1;
@@ -690,25 +696,25 @@
 
 	printf("Doing ede_ofb64\n");
 	DES_set_key_checked(&ofb_key,&ks);
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
-	memset(ofb_buf1,0,sizeof(ofb_buf1));
-	memset(ofb_buf2,0,sizeof(ofb_buf1));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memset(ofb_buf1,0,sizeof(ofb_buf1));
+	op_memset(ofb_buf2,0,sizeof(ofb_buf1));
 	num=0;
 	for (i=0; i<sizeof(plain); i++)
 		{
 		des_ede3_ofb64_encrypt(&(plain[i]),&(ofb_buf1[i]),1,ks,ks,
 				       ks,&ofb_tmp,&num);
 		}
-	if (memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
+	if (op_memcmp(ofb_cipher,ofb_buf1,sizeof(ofb_buf1)) != 0)
 		{
 		printf("ede_ofb64_encrypt encrypt error\n");
 		err=1;
 		}
-	memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
+	op_memcpy(ofb_tmp,ofb_iv,sizeof(ofb_iv));
 	num=0;
 	des_ede3_ofb64_encrypt(ofb_buf1,ofb_buf2,sizeof(ofb_buf1),ks,ks,ks,
 			       &ofb_tmp,&num);
-	if (memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
+	if (op_memcmp(plain,ofb_buf2,sizeof(ofb_buf2)) != 0)
 		{
 		printf("ede_ofb64_encrypt decrypt error\n");
 		err=1;
@@ -723,7 +729,7 @@
 			(unsigned long)cs,(unsigned long)cbc_cksum_ret);
 		err=1;
 		}
-	if (memcmp(cret,cbc_cksum_data,8) != 0)
+	if (op_memcmp(cret,cbc_cksum_data,8) != 0)
 		{
 		printf("bad cbc_cksum block returned\n");
 		err=1;
@@ -796,7 +802,7 @@
 		{
 		printf(" %d",i);
 		des_ncbc_encrypt(&(cbc_out[i]),cbc_in,
-				 strlen((char *)cbc_data)+1,ks,
+				 op_strlen((char *)cbc_data)+1,ks,
 				 &cbc_iv,DES_ENCRYPT);
 		}
 	printf("\noutput word alignment test");
@@ -804,19 +810,19 @@
 		{
 		printf(" %d",i);
 		des_ncbc_encrypt(cbc_out,&(cbc_in[i]),
-				 strlen((char *)cbc_data)+1,ks,
+				 op_strlen((char *)cbc_data)+1,ks,
 				 &cbc_iv,DES_ENCRYPT);
 		}
 	printf("\n");
 	printf("fast crypt test ");
 	str=crypt("testing","ef");
-	if (strcmp("efGnQx2725bI2",str) != 0)
+	if (op_strcmp("efGnQx2725bI2",str) != 0)
 		{
 		printf("fast crypt error, %s should be efGnQx2725bI2\n",str);
 		err=1;
 		}
 	str=crypt("bca76;23","yA");
-	if (strcmp("yA1Rp/1hZXIJk",str) != 0)
+	if (op_strcmp("yA1Rp/1hZXIJk",str) != 0)
 		{
 		printf("fast crypt error, %s should be yA1Rp/1hZXIJk\n",str);
 		err=1;
@@ -855,20 +861,20 @@
 	int i,err=0;
 
 	DES_set_key_checked(&cfb_key,&ks);
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	des_cfb_encrypt(plain,cfb_buf1,bits,sizeof(plain),ks,&cfb_tmp,
 			DES_ENCRYPT);
-	if (memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
+	if (op_memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("cfb_encrypt encrypt error\n");
 		for (i=0; i<24; i+=8)
 			printf("%s\n",pt(&(cfb_buf1[i])));
 		}
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	des_cfb_encrypt(cfb_buf1,cfb_buf2,bits,sizeof(plain),ks,&cfb_tmp,
 			DES_DECRYPT);
-	if (memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
+	if (op_memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("cfb_encrypt decrypt error\n");
@@ -884,24 +890,24 @@
 	int err=0,i,n;
 
 	DES_set_key_checked(&cfb_key,&ks);
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	n=0;
 	des_cfb64_encrypt(plain,cfb_buf1,12,ks,&cfb_tmp,&n,DES_ENCRYPT);
 	des_cfb64_encrypt(&(plain[12]),&(cfb_buf1[12]),sizeof(plain)-12,ks,
 			  &cfb_tmp,&n,DES_ENCRYPT);
-	if (memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
+	if (op_memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("cfb_encrypt encrypt error\n");
 		for (i=0; i<24; i+=8)
 			printf("%s\n",pt(&(cfb_buf1[i])));
 		}
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	n=0;
 	des_cfb64_encrypt(cfb_buf1,cfb_buf2,17,ks,&cfb_tmp,&n,DES_DECRYPT);
 	des_cfb64_encrypt(&(cfb_buf1[17]),&(cfb_buf2[17]),
 			  sizeof(plain)-17,ks,&cfb_tmp,&n,DES_DECRYPT);
-	if (memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
+	if (op_memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("cfb_encrypt decrypt error\n");
@@ -917,28 +923,28 @@
 	int err=0,i,n;
 
 	DES_set_key_checked(&cfb_key,&ks);
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	n=0;
 	des_ede3_cfb64_encrypt(plain,cfb_buf1,12,ks,ks,ks,&cfb_tmp,&n,
 			       DES_ENCRYPT);
 	des_ede3_cfb64_encrypt(&(plain[12]),&(cfb_buf1[12]),
 			       sizeof(plain)-12,ks,ks,ks,
 			       &cfb_tmp,&n,DES_ENCRYPT);
-	if (memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
+	if (op_memcmp(cfb_cipher,cfb_buf1,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("ede_cfb_encrypt encrypt error\n");
 		for (i=0; i<24; i+=8)
 			printf("%s\n",pt(&(cfb_buf1[i])));
 		}
-	memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
+	op_memcpy(cfb_tmp,cfb_iv,sizeof(cfb_iv));
 	n=0;
 	des_ede3_cfb64_encrypt(cfb_buf1,cfb_buf2,(long)17,ks,ks,ks,
 			       &cfb_tmp,&n,DES_DECRYPT);
 	des_ede3_cfb64_encrypt(&(cfb_buf1[17]),&(cfb_buf2[17]),
 			       sizeof(plain)-17,ks,ks,ks,
 			       &cfb_tmp,&n,DES_DECRYPT);
-	if (memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
+	if (op_memcmp(plain,cfb_buf2,sizeof(plain)) != 0)
 		{
 		err=1;
 		printf("ede_cfb_encrypt decrypt error\n");
diff -Naur openssl-1.0.0q.orig/crypto/des/ecb3_enc.c openssl-1.0.0q/crypto/des/ecb3_enc.c
--- openssl-1.0.0q.orig/crypto/des/ecb3_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/ecb3_enc.c	2017-04-25 16:23:40.162528195 +0200
@@ -56,6 +56,7 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
 #include "des_locl.h"
 
 void DES_ecb3_encrypt(const_DES_cblock *input, DES_cblock *output,
diff -Naur openssl-1.0.0q.orig/crypto/des/ecb_enc.c openssl-1.0.0q/crypto/des/ecb_enc.c
--- openssl-1.0.0q.orig/crypto/des/ecb_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/ecb_enc.c	2017-04-25 16:23:40.162528195 +0200
@@ -56,6 +56,7 @@
  * [including the GNU Public Licence.]
  */
 
+#include <openssl/cryptlib.h>
 #include "des_locl.h"
 #include "des_ver.h"
 #include <openssl/opensslv.h>
diff -Naur openssl-1.0.0q.orig/crypto/des/enc_read.c openssl-1.0.0q/crypto/des/enc_read.c
--- openssl-1.0.0q.orig/crypto/des/enc_read.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/enc_read.c	2017-04-25 16:23:40.163527205 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include "des_locl.h"
 
@@ -127,7 +129,7 @@
 			/* we still still need more data but will return
 			 * with the number of bytes we have - should always
 			 * check the return value */
-			memcpy(buf,&(unnet[unnet_start]),
+			op_memcpy(buf,&(unnet[unnet_start]),
 			       unnet_left);
 			/* eay 26/08/92 I had the next 2 lines
 			 * reversed :-( */
@@ -136,7 +138,7 @@
 			}
 		else
 			{
-			memcpy(buf,&(unnet[unnet_start]),len);
+			op_memcpy(buf,&(unnet[unnet_start]),len);
 			unnet_start+=len;
 			unnet_left-=len;
 			i=len;
@@ -195,7 +197,7 @@
 			DES_pcbc_encrypt(net,unnet,num,sched,iv,DES_DECRYPT);
 		else
 			DES_cbc_encrypt(net,unnet,num,sched,iv,DES_DECRYPT);
-		memcpy(buf,unnet,len);
+		op_memcpy(buf,unnet,len);
 		unnet_start=len;
 		unnet_left=num-len;
 
@@ -222,7 +224,7 @@
 
 			/* eay 26/08/92 fix a bug that returned more
 			 * bytes than you asked for (returned len bytes :-( */
-			memcpy(buf,tmpbuf,num);
+			op_memcpy(buf,tmpbuf,num);
 			}
 		else
 			{
diff -Naur openssl-1.0.0q.orig/crypto/des/enc_writ.c openssl-1.0.0q/crypto/des/enc_writ.c
--- openssl-1.0.0q.orig/crypto/des/enc_writ.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/enc_writ.c	2017-04-25 16:23:40.164526494 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <errno.h>
 #include <time.h>
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include "des_locl.h"
 #include <openssl/rand.h>
@@ -84,7 +86,7 @@
 	return (-1);
 #else
 #ifdef _LIBC
-	extern unsigned long time();
+	extern unsigned long op_time();
 	extern int write();
 #endif
 	const unsigned char *buf=_buf;
@@ -132,7 +134,7 @@
 	if (len < 8)
 		{
 		cp=shortbuf;
-		memcpy(shortbuf,buf,len);
+		op_memcpy(shortbuf,buf,len);
 		RAND_pseudo_bytes(shortbuf+len, 8-len);
 		rnum=8;
 		}
diff -Naur openssl-1.0.0q.orig/crypto/des/fcrypt.c openssl-1.0.0q/crypto/des/fcrypt.c
--- openssl-1.0.0q.orig/crypto/des/fcrypt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/fcrypt.c	2017-04-25 16:23:40.165530253 +0200
@@ -1,5 +1,10 @@
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 /* NOCW */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifdef _OSD_POSIX
 #ifndef CHARSET_EBCDIC
 #define CHARSET_EBCDIC 1
@@ -74,7 +79,7 @@
 	    e_salt[1] = salt[1];
 
 	/* Copy at most 32 chars of password */
-	strncpy (e_buf, buf, sizeof(e_buf));
+	op_strncpy (e_buf, buf, sizeof(e_buf));
 
 	/* Make sure we have a delimiter */
 	e_salt[sizeof(e_salt)-1] = e_buf[sizeof(e_buf)-1] = '\0';
@@ -89,7 +94,7 @@
 	ret = DES_fcrypt(e_buf,e_salt,buff);
 
 	/* Convert the result back to EBCDIC */
-	ascii2ebcdic(ret, ret, strlen(ret));
+	ascii2ebcdic(ret, ret, op_strlen(ret));
 	
 	return ret;
 #endif
@@ -128,7 +133,7 @@
 #endif
 
 /* EAY
-r=strlen(buf);
+r=op_strlen(buf);
 r=(r+7)/8;
 */
 	for (i=0; i<8; i++)
diff -Naur openssl-1.0.0q.orig/crypto/des/fcrypt_b.c openssl-1.0.0q/crypto/des/fcrypt_b.c
--- openssl-1.0.0q.orig/crypto/des/fcrypt_b.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/fcrypt_b.c	2017-04-25 16:23:40.166527027 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 /* This version of crypt has been developed from my MIT compatible
  * DES library.
diff -Naur openssl-1.0.0q.orig/crypto/des/ncbc_enc.c openssl-1.0.0q/crypto/des/ncbc_enc.c
--- openssl-1.0.0q.orig/crypto/des/ncbc_enc.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/ncbc_enc.c	2017-04-25 16:23:40.167527713 +0200
@@ -63,6 +63,8 @@
 
 #include "des_locl.h"
 
+#ifdef SSL_USE_WEAK_CIPHERS
+
 #ifdef CBC_ENC_C__DONT_UPDATE_IV
 void DES_cbc_encrypt(const unsigned char *in, unsigned char *out, long length,
 		     DES_key_schedule *_schedule, DES_cblock *ivec, int enc)
@@ -146,3 +148,5 @@
 	tin0=tin1=tout0=tout1=xor0=xor1=0;
 	tin[0]=tin[1]=0;
 	}
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/des/opera_cbc3_enc.cpp openssl-1.0.0q/crypto/des/opera_cbc3_enc.cpp
--- openssl-1.0.0q.orig/crypto/des/opera_cbc3_enc.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/des/opera_cbc3_enc.cpp	2017-04-25 16:23:40.168527561 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "cbc3_enc.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/des/opera_ecb3_enc.cpp openssl-1.0.0q/crypto/des/opera_ecb3_enc.cpp
--- openssl-1.0.0q.orig/crypto/des/opera_ecb3_enc.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/des/opera_ecb3_enc.cpp	2017-04-25 16:23:40.171527384 +0200
@@ -0,0 +1,17 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2009 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+#include "modules/libopeay/core_includes.h"
+
+#if defined(_SSL_USE_OPENSSL_) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
+extern "C" {
+#include "modules/libopeay/openssl/cryptlib.h"
+#include "modules/libopeay/crypto/des/ecb3_enc.c"
+}
+#endif 
diff -Naur openssl-1.0.0q.orig/crypto/des/opera_ecb_enc.cpp openssl-1.0.0q/crypto/des/opera_ecb_enc.cpp
--- openssl-1.0.0q.orig/crypto/des/opera_ecb_enc.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/des/opera_ecb_enc.cpp	2017-04-25 16:23:40.171527384 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "ecb_enc.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/des/read2pwd.c openssl-1.0.0q/crypto/des/read2pwd.c
--- openssl-1.0.0q.orig/crypto/des/read2pwd.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/des/read2pwd.c	2017-04-25 16:23:40.172528069 +0200
@@ -109,7 +109,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/des.h>
 #include <openssl/ui.h>
 #include <openssl/crypto.h>
diff -Naur openssl-1.0.0q.orig/crypto/des/read_pwd.c openssl-1.0.0q/crypto/des/read_pwd.c
--- openssl-1.0.0q.orig/crypto/des/read_pwd.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/read_pwd.c	2017-04-25 16:23:40.173527638 +0200
@@ -56,6 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <openssl/e_os2.h>
 #if !defined(OPENSSL_SYS_MSDOS) && !defined(OPENSSL_SYS_VMS) && !defined(OPENSSL_SYS_WIN32)
 #ifdef OPENSSL_UNISTD
@@ -87,10 +90,14 @@
 #include "des_locl.h"
 #include "cryptlib.h"
 #include <signal.h>
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <setjmp.h>
+#ifndef OPERA_SMALL_VERSION
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #ifdef OPENSSL_SYS_VMS			/* prototypes for sys$whatever */
 #include <starlet.h>
@@ -100,7 +107,9 @@
 #endif
 
 #ifdef WIN_CONSOLE_BUG
+#ifndef OPERA_SMALL_VERSION
 #include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifndef OPENSSL_SYS_WINCE
 #include <wincon.h>
 #endif
@@ -228,8 +237,8 @@
 
 int des_read_pw(char *buf, char *buff, int size, const char *prompt, int verify)
 	{ 
-	memset(buf,0,size);
-	memset(buff,0,size);
+	op_memset(buf,0,size);
+	op_memset(buff,0,size);
 	return(0);
 	}
 
@@ -237,8 +246,8 @@
 
 int des_read_pw(char *buf, char *buff, int size, char *prompt, int verify)
 	{ 
-	memset(buf,0,size);
-	memset(buff,0,size);
+	op_memset(buf,0,size);
+	op_memset(buff,0,size);
 	return(0);
 	}
 
@@ -251,7 +260,7 @@
 
 	do	{
 		fgets(buf,SIZE,in);
-		} while (strchr(buf,'\n') == NULL);
+		} while (op_strchr(buf,'\n') == NULL);
 	}
 
 
@@ -320,7 +329,7 @@
 #endif
 			return(-1);
 		}
-	memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
+	op_memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
 #endif
 #ifdef OPENSSL_SYS_VMS
 	status = sys$assign(&terminal,&channel,0,0);
@@ -379,7 +388,7 @@
 				*p='\0';
 			else	read_till_nl(tty);
 				
-			if (strcmp(buf,buff) != 0)
+			if (op_strcmp(buf,buff) != 0)
 				{
 				fprintf(stderr,"\nVerify failure");
 				fflush(stderr);
@@ -419,7 +428,7 @@
 #ifdef SIGACTION
 	struct sigaction sa;
 
-	memset(&sa,0,sizeof sa);
+	op_memset(&sa,0,sizeof sa);
 	sa.sa_handler=recsig;
 #endif
 
@@ -515,7 +524,7 @@
 			FlushConsoleInputBuffer(inh);
 		}
 #endif
-	return(strlen(buf));
+	return(op_strlen(buf));
 	}
 #endif
 #endif /* !OPENSSL_SYS_WINCE && !WIN16 */
diff -Naur openssl-1.0.0q.orig/crypto/des/rpc_des.h openssl-1.0.0q/crypto/des/rpc_des.h
--- openssl-1.0.0q.orig/crypto/des/rpc_des.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/rpc_des.h	2017-04-25 16:23:40.174527765 +0200
@@ -112,7 +112,7 @@
 	unsigned char des_ivec[8];	/* input vector */
 	unsigned des_len;	/* number of bytes to crypt */
 	union {
-		unsigned char UDES_data[DES_QUICKLEN];
+		unsigned char UDES_data[DES_QUICKLEN]; /* ARRAY OK UNUSED OPERA 2004-02-18 yngve*/
 		unsigned char *UDES_buf;
 	} UDES;
 #	define des_data UDES.UDES_data	/* direct data here if quick */
diff -Naur openssl-1.0.0q.orig/crypto/des/rpw.c openssl-1.0.0q/crypto/des/rpw.c
--- openssl-1.0.0q.orig/crypto/des/rpw.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/rpw.c	2017-04-25 16:23:40.175527892 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/des.h>
 
 int main(int argc, char *argv[])
diff -Naur openssl-1.0.0q.orig/crypto/des/set_key.c openssl-1.0.0q/crypto/des/set_key.c
--- openssl-1.0.0q.orig/crypto/des/set_key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/des/set_key.c	2017-04-25 16:23:40.176528019 +0200
@@ -63,8 +63,10 @@
  * 1.1 added norm_expand_bits
  * 1.0 First working version
  */
+#include <openssl/cryptlib.h>
 #include "des_locl.h"
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 OPENSSL_IMPLEMENT_GLOBAL(int,DES_check_key,0)	/* defaults to false */
 
 static const unsigned char odd_parity[256]={
@@ -146,9 +148,10 @@
 		 * eay 93/06/29
 		 * Another problem, I was comparing only the first 4
 		 * bytes, 97/03/18 */
-		if (memcmp(weak_keys[i],key,sizeof(DES_cblock)) == 0) return(1);
+		if (op_memcmp(weak_keys[i],key,sizeof(DES_cblock)) == 0) return(1);
 	return(0);
 	}
+#endif
 
 /* NOW DEFINED IN des_local.h
  * See ecb_encrypt.c for a pseudo description of these macros. 
@@ -307,6 +310,7 @@
 	0x00002822L,0x04002822L,0x00042822L,0x04042822L,
 	}};
 
+#ifdef SSL_USE_WEAK_CIPHERS
 int DES_set_key(const_DES_cblock *key, DES_key_schedule *schedule)
 	{
 	if (DES_check_key)
@@ -333,6 +337,7 @@
 	DES_set_key_unchecked(key, schedule);
 	return 0;
 	}
+#endif
 
 void DES_set_key_unchecked(const_DES_cblock *key, DES_key_schedule *schedule)
 	{
@@ -343,7 +348,7 @@
 	register int i;
 
 #ifdef OPENBSD_DEV_CRYPTO
-	memcpy(schedule->key,key,sizeof schedule->key);
+	op_memcpy(schedule->key,key,sizeof schedule->key);
 	schedule->session=NULL;
 #endif
 	k = &schedule->ks->deslong[0];
@@ -394,10 +399,12 @@
 		}
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int DES_key_sched(const_DES_cblock *key, DES_key_schedule *schedule)
 	{
 	return(DES_set_key(key,schedule));
 	}
+#endif
 /*
 #undef des_fixup_key_parity
 void des_fixup_key_parity(des_cblock *key)
diff -Naur openssl-1.0.0q.orig/crypto/des/speed.c openssl-1.0.0q/crypto/des/speed.c
--- openssl-1.0.0q.orig/crypto/des/speed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/des/speed.c	2017-04-25 16:23:40.177527588 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -75,10 +77,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -96,7 +102,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/des/str2key.c openssl-1.0.0q/crypto/des/str2key.c
--- openssl-1.0.0q.orig/crypto/des/str2key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/des/str2key.c	2017-04-25 16:23:40.178527715 +0200
@@ -65,8 +65,8 @@
 	int i,length;
 	register unsigned char j;
 
-	memset(key,0,8);
-	length=strlen(str);
+	op_memset(key,0,8);
+	length=op_strlen(str);
 #ifdef OLD_STR_TO_KEY
 	for (i=0; i<length; i++)
 		(*key)[i%8]^=(str[i]<<1);
@@ -105,9 +105,9 @@
 	int i,length;
 	register unsigned char j;
 
-	memset(key1,0,8);
-	memset(key2,0,8);
-	length=strlen(str);
+	op_memset(key1,0,8);
+	op_memset(key2,0,8);
+	length=op_strlen(str);
 #ifdef OLD_STR_TO_KEY
 	if (length <= 8)
 		{
@@ -148,7 +148,7 @@
 				(*key2)[7-(i%8)]^=j;
 			}
 		}
-	if (length <= 8) memcpy(key2,key1,8);
+	if (length <= 8) op_memcpy(key2,key1,8);
 #endif
 	DES_set_odd_parity(key1);
 	DES_set_odd_parity(key2);
diff -Naur openssl-1.0.0q.orig/crypto/dh/.gitignore openssl-1.0.0q/crypto/dh/.gitignore
--- openssl-1.0.0q.orig/crypto/dh/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/.gitignore	2017-04-25 16:23:40.179526724 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
